#!/bin/bash

# get information from automatic documentation,
curl "http://127.0.0.1:8000/openapi.json" > toardb_fastapi.yaml
# prepare documentation for pages
python3 prepare_openapi_json.py toardb_fastapi.yaml 
# convert OpenAPI format to Markdown
openapi-markdown --skip-info -i sample.json

# also get controlled_vocabulary
curl "http://127.0.0.1:8000/controlled_vocabulary/" >controlled_vocabulary.json
# giving credit to torsimany (although it was not working, it was a good starting point)
torsimany controlled_vocabulary.json
# some more pretty printing for the "tables"
cat controlled_vocabulary.markdown | sed -E 's/\], \[/\],  \n \[/g' | sed -E 's/\[\[/\[  \n \[/g' | sed -E 's/#/####/g' >controlled_vocabulary.md


# last pretty print changes for pages
(
cat <<'EOF'
# TOAR II Database

### Models

EOF
) > sample_header.md
(
cat <<'EOF'


## REST API

EOF
) > sample_rest_header.md
sed '1,/^### Models$/d' sample.md >sample_models.md
sed '/^### Models$/Q' sample.md >sample_rest.md
(
cat <<'EOF'


## controlled vocabulary

EOF
) > controlled_vocabulary_header.md

cat sample_header.md sample_models.md controlled_vocabulary_header.md controlled_vocabulary.md sample_rest_header.md sample_rest.md >../docs/toardb_fastapi.md
rm sample* controlled* toardb_fastapi.yaml
